;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;				Сортировка с анимацией	v1.0
;;		Управление
;; Пробел: старт/стоп
;; Ентер: сброс
;; + / -: быстрей/медленей
;;
;; (с) Intro  wasm.in			Создан: 24‎.12.‎2022 19:16	Изменён: 25‎.12.‎2022 22:18
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
_USE_FUNC_ExitProcess_		EQU <>	;использовать ExitProcess для завершения

.386
;.XMM
.model flat,stdcall
option casemap:none
option SWITCHSTYLE:ASMSTYLE
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc
include \masm32\include\comctl32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\comctl32.lib
include msvcrt.inc
include macros.asm

;флаги главного окна! 
WS_MAIN_FORM		= WS_VISIBLE or WS_OVERLAPPED or WS_CAPTION or WS_SYSMENU or WS_MINIMIZEBOX; or ; OR WS_MAXIMIZEBOX
MS_BASE_LABEL		= WS_CHILD or WS_VISIBLE or SS_BITMAP

CountElements		= 140
ColumnWidth			= 10	;ширина - 1, 1 пиксель между столбиками
ColumnHeight		= 512
FormWidth			= CountElements*ColumnWidth+9
FormHeight			= 650

;ID'шники контролов
MAIN_FORM_ID		= 0
TIMER_ID			= 1000

.const
ClassName			db "Bubble Sort",0
align 4
aStatic				db "static", 0
align 4
QrtCountElements	dword CountElements*CountElements

.data?
hInstance			dword ?
Array				dword CountElements dup(?)
hwndColumns			dword CountElements dup(?)
bUpdateColumns		byte CountElements dup(?)
align 4
count				dword ?
hwndMainForm		dword ?
ThreadID			dword ?
ColorColumn			dword 512 dup(?)
g_bStart			byte ?
g_bStop				byte ?
g_bBreak			byte ?

.code
WinMain proc hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
local wc:WNDCLASSEX, msg:MSG
;edi -	hWnd:HWND
	lea		esi, wc
	ASSUME	esi:ptr WNDCLASSEX, edi:ptr MSG
	mov		[esi].cbSize, sizeof WNDCLASSEX
	mov		[esi].style, CS_BYTEALIGNCLIENT
	mov		[esi].lpfnWndProc, offset WndProc
	mov		[esi].cbClsExtra, NULL
	mov		[esi].cbWndExtra, NULL
	mov		eax, hInst
	mov		[esi].hInstance, eax
	mov		hInstance, eax
	mov		[esi].hbrBackground, COLOR_WINDOWTEXT
	mov		[esi].lpszClassName, offset ClassName
	mov		[esi].hIcon, LoadIcon(NULL, IDI_APPLICATION)
	mov		[esi].hIconSm, eax
	mov		[esi].hCursor, LoadCursor(NULL, IDC_ARROW)
	RegisterClassEx(esi)
	mov		ebx, CreateWindowEx(0,&ClassName,NULL,WS_MAIN_FORM,250,50,FormWidth,FormHeight,0,MAIN_FORM_ID,hInst,0)
	mov		hwndMainForm, eax
	ShowWindow(ebx, SW_SHOWNORMAL)
	UpdateWindow(ebx)
	lea		edi, msg
	.while (true)
		GetMessage(edi, 0, 0, 0)
		.break .if (!eax)
		TranslateMessage(edi)
		DispatchMessage(edi)
	.endw
	mov		eax, [edi].wParam
	ASSUME	esi:nothing, edi:nothing
	ret
WinMain endp

align_proc
ColorGradient proc (dword) len:dword
local res:CRGB
	mov		res.bExtra, 0
	mov		eax, len
	.if (eax<128)	;96;64;32
		mov		dl, 255	;192+64
		add		al, al
		sub		dl, al		;r:255-127
	.elseif (eax<224)	;192;160		;128-159
		mov		dl, 0
	.elseif (eax<342)	;310;288;256
		sub		eax, 224
		mov		dl, al
	.elseif (eax<374)
		mov		dl, 72h
	.elseif (eax<470)	;438;406
		sub		eax, 374
		mov		dl, 72h	;91h
		add		dl, al
	.else
		mov		dl, 0CFh	;0EEh
		sub		eax, 470
		add		dl, al
	.endif
	mov		res.bRed, dl
;----blue-------------------------------------
	mov		eax, len
	.if (eax<64)
		xor		dl, dl
	.elseif (eax<128) ;96	;64-95
		sub		al, 64
		add		al, al
		mov		dl, al
	.elseif (eax<160)	;128-159
		sub		al, 128
		mov		dl, 128
		add		dl, al		;b=190
	.elseif (eax<192)	;255-383
		sub		eax, 160
		mov		dl, 159;192
		add		dl, al
	.elseif (eax<224)	;384-447
		mov		dl, 190	;222
		sub		eax, 192
		add		dl, al
	.elseif (eax<256)
		sub		eax, 224
		mov		dl, 221
	.elseif (eax<288)
		sub		eax, 256
		mov		dl, 0DDh
		sub		dl, al
	.elseif (eax<310)
		mov		dl, 0BEh
		sub		eax, 288
		sub		dl, al
	.elseif (eax<342)
		mov		dl, 0A9h
		sub		eax, 310
		sub		dl, al
	.elseif (eax<374)
		mov		dl, 8Ah
		sub		eax, 342
		sub		dl, al
	.elseif (eax<406)
		mov		dl, 6Bh
		sub		eax, 374
		sub		dl, al
	.elseif (eax<438)
		mov		dl, 4Ch
		sub		eax, 406
		sub		dl, al
	.elseif (eax<470)
		mov		dl, 2Dh
		sub		eax, 438
		sub		dl, al
	.else
		mov		dl, 0Eh
		sub		dl, al
	.endif
	mov		res.bBlue, dl
;---green---------------------------------
	mov		eax, len
	.if (eax<64) 	;0-31
		add		al, al
		mov		dl, 128
		add		dl, al	;g:127-255	
	.elseif (eax<96)	;64-95
		mov		dl, 255;g=255
	.elseif (eax<128)	;96-127
		mov		dl, 255
		sub		al, 96
		add		al, al
		sub		dl, al;g=255-192
	.elseif (eax<310) ;160;128-159
		sub		al, 128
		mov		dl, 192
		sub		dl, al
	.else
		mov		dl, 0
	.endif
	mov		res.bGreen, dl
;------------------------------------
	mov		eax, res
	ret
ColorGradient endp

align_proc
ProcessSort proc uses esi edi ebx dummy:dword
local flag:byte
	mov		g_bStart, true
	mov		esi, CountElements-1
	.repeat
		mov		flag, 0		  ;флаг Ц были/не были перестановки в проходе
		mov		edi, CountElements-1
		mov		ebx, edi	;=r
		sub		ebx, esi
		.repeat
			mov		eax, Array[edi*4]
			.if (eax<Array[edi*4-4])
				mov		flag, 1
				inc		count
				;swap(A[j-1], A[j])
				mov		edx, eax
				mov		eax, Array[edi*4-4]
				mov		Array[edi*4-4], edx
				mov		Array[edi*4], eax
				mov		bUpdateColumns[edi-1], true
				mov		bUpdateColumns[edi], true
				Sleep(20)
				.repeat	;//приостановить процесс сортировки
					.if (g_bBreak)
						jmp		EXIT
					.endif
				.until (g_bStop==false)
			.endif
			dec		edi		;j--
		.until (edi<=ebx)
		dec		esi
	.until (zero? || !flag)
EXIT:
	mov		g_bStart, false
	xor		eax, eax
	ret
ProcessSort endp

align_proc
Reset proc uses edi
local time:SYSTEMTIME
	GetLocalTime(&time)
	movzx	eax, time.wSecond
	inc		eax
	shr		eax, 1	;/=2
	imul	ax, time.wMilliseconds
	srand(eax)
	.for (edi=0: edi<CountElements: edi++)
		rand()		;0..32767
		shr		eax, 6		;/=64
	;	and		eax, 1FFh	;%=512
		mov		Array[edi*4], eax	;0..511
		mov		bUpdateColumns[edi], true
	.endfor
	ret
Reset endp

sWPARAM union ; (sizeof=4, align=4)
	w				dword ?		;
	struct
		lo			word ?		;
		hi			word ?		;
	ends
	struct
		b0			byte ?		;
		b1			byte ?		;
		b2			byte ?		;
		b3			byte ?		;
	ends
sWPARAM ends

align_proc
WndProc proc uses esi edi ebx hWnd:HWND, uMsg:UINT, wParam:sWPARAM, lParam:sWPARAM
local	hDC:dword, m:real8, rect:RECT, buffer[80]:byte
	.if (uMsg == WM_TIMER)
		.if (g_bBreak && g_bStart==false)
			Reset()
			and		count, 0	;=0
			mov		g_bBreak, false
		.endif
		mov		hDC, GetDC(hWnd)
		SetTextColor(hDC, 0FFFFFFh)
		SetBkColor(hDC, 0)
		.if (count)
			;double	m = (double)CountElements*CountElements/(double)count;
			fild	QrtCountElements
			fidiv	count
		.else
			fldz
		.endif
		fstp	m
		sprintf(&buffer, "BubbleSort: Array i=%d, Comparisons: (i*i)/%d = %.5f   ", CountElements, count, m)
		TextOut(hDC, 0, 0, &buffer, eax)
		ReleaseDC(hWnd, hDC)
		.for (edi=0: edi<CountElements: edi++)
			.if (bUpdateColumns[edi])
				mov		hDC, GetDC(hwndColumns[edi*4])
				mov		ebx, ColumnHeight
				xor		esi, esi
				SetPixel(hDC, esi, esi, 0)
				StretchBlt(hDC, esi, esi, ColumnWidth-1, ebx, hDC, esi, esi, 1,1, SRCCOPY)
				mov		esi, Array[edi*4]
				sub		ebx, esi
				dec		ebx
				SetPixel(hDC, 0, ebx, ColorColumn[esi*4])
				StretchBlt(hDC, 0, ebx, ColumnWidth-1, &[esi+1], hDC, 0, ebx, 1,1, SRCCOPY)
				mov		bUpdateColumns[edi], false
				ReleaseDC(hwndColumns[edi*4], hDC)
			.endif
		.endfor
	.elseif (uMsg == WM_SETFOCUS)
		mov		al ,true
		mov		edi, offset bUpdateColumns
		mov		ecx, CountElements
		rep stosb
	.elseif (uMsg == WM_CREATE)
		xor		edi, edi
		.repeat
			mov		ColorColumn[edi*4], ColorGradient(edi)
			inc		edi
		.until (edi>=512)
		GetClientRect(hWnd, &rect)
		mov		ebx, rect.bottom
		sub		ebx, ColumnHeight
		.for (edi=0, esi=2: edi<CountElements: edi++, esi+=ColumnWidth);edi - i, esi - x
			mov		hwndColumns[edi*4], CreateWindowEx(0, &aStatic, NULL, MS_BASE_LABEL, esi, ebx, ColumnWidth-1, ColumnHeight, hWnd, &[edi+1], hInstance, 0)
		.endfor
		Reset()
		SetTimer(hWnd, TIMER_ID, 20, NULL)
	.elseif (uMsg == WM_KEYDOWN)	;отслеживаем клавиатуру
		mov		bl, wParam.b0		;key = wParam & 0xFF;
		.if (bl==' ')		;Space	start
			.if (!g_bStart)
				xor		edx, edx
				mov		g_bStop, dl;=false
				mov		count, edx	;=0
				CreateThread(edx, edx, &ProcessSort, edx, NORMAL_PRIORITY_CLASS, &ThreadID)
			.else
				xor		g_bStop, 1
			.endif
		.elseif (bl==13)	;Enter	clear
			.if (!g_bStart)
				Reset()
			.else
				mov		g_bBreak, true
			.endif
		.endif
	.elseif (uMsg == WM_DESTROY)
		PostQuitMessage(NULL)
	.else
		DefWindowProc(hWnd, uMsg, wParam, lParam)
		;//перемещаем форму за любую часть!
		.if (uMsg == WM_NCHITTEST && eax == HTCLIENT)
			mov		eax, HTCAPTION
		.endif
		jmp		EXIT
	.endif
	mov		eax, TRUE
EXIT:
	ret
WndProc endp

main_startup_Win32_END